Index: trunk/LMDZ.GENERIC/deftank/callphys.earthslab
===================================================================
--- trunk/LMDZ.GENERIC/deftank/callphys.earth	(revision 2972)
+++ trunk/LMDZ.GENERIC/deftank/callphys.earthslab	(revision 3100)
@@ -4,5 +4,5 @@
 tracer    = .true.
 # Diurnal cycle ?  if diurnal=false, diurnally averaged solar heating
-diurnal   = .false.
+diurnal   = .true.
 # Seasonal cycle ? if season=false, Ls stays constant, to value set in "start"
 season    = .true. 
@@ -17,6 +17,13 @@
 # Test energy conservation of model physics ?
 enertest  = .false.
-# Check to see if cpp, mugaz values used match gas mixture defined in gases.def (recommended) ?
-check_cpp_match=.true.
+# check if cpp and mugaz from start.nc are consistent with values computed by comp_cpp_mugaz with gases.def
+check_cpp_match = .false.
+# Check if physics inputs and outputs are ok
+check_physics_inputs = .true.
+check_physics_outputs = .true.
+
+## Directory where external input files are
+## ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+datadir     = datadir
 
 ## Radiative transfer options
@@ -26,27 +33,55 @@
 # the rad. transfer is computed every "iradia" physical timestep
 iradia     = 6
+# Use blackbody for stellar spectrum ?
+stelbbody    = .false.
+# Stellar blackbody temperature ?
+stelTbb      = 2000.000
 # call multilayer correlated-k radiative transfer ?
 corrk      = .true.
-# Include continuum absorption in radiative transfer (note CO2 is treated separately) ?
-continuum  = .true.
 # folder in which correlated-k data is stored ?
-corrkdir   = N2CO2poor_H2Ovar
+corrkdir = Earth_JL13_extend
+# corrkdir    = Earth_110-710K
+# corrkdir   = N2CO2poor_H2Ovar
+# corrkdir   = megaCO2
+# corrkdir   = null
 # call visible gaseous absorption in radiative transfer ?
 callgasvis = .true.
+# call continuum in radiative transfer ?
+Continuum = .true.
 # Include Rayleigh scattering in the visible ?
 rayleigh   = .true.
+# Uniform absorption coefficient in radiative transfer?
+graybody     = .false.
+# Constant absorption coefficient in visible 
+#      (in m^2/kg; only if graybody=true):
+#      tau_surf= kappa*P/g
+kappa_VI = 1.e-4
+# Constant absorption coefficient in IR
+#      (in m^2/kg; only if graybody=true):
+kappa_IR = 5.e-1 
+# Use Newtonian cooling in place of radiative transfer ?
+newtonian    = .false.
+# Radiative timescale for Newtonian cooling ? [only if newtonian = T]
+tau_relax    = 30.00000
+# Test physics timescale in 1D ?
+testradtimes = .false.
 # Characteristic planetary equilibrium (black body) temperature
 # This is used only in the aerosol radiative transfer setup. (see aerave.F)
 tplanet    = 215.
-# Output spectral OLR in 3D?
+# Output spectral OLR in 1D/3D?
 specOLR    = .false.
 # Output global radiative balance in file 'rad_bal.out' - slow for 1D!!
-meanOLR    = .true.
+meanOLR    = .false.
 # Variable gas species: Radiatively active ?
 varactive  = .true.
 # Variable gas species: Fixed vertical distribution ?
+#   (not to be used in time integration mode)
 varfixed   = .false.
 # Variable gas species: Saturation percentage value at ground ?
-satval     = 0.0
+satval     = .8
+# Use fixed vertical profile, 1 step, no iteration ?
+kastprof     = .false.
+# Remove lower boundary (e.g. for gas giant sims)
+noradsurf    = .false. 
 
 ## Star type
@@ -60,6 +95,4 @@
 #       startype = 3            GJ644
 #       startype = 4            HD128167
-#       startype = 9            TRAPPIST-1
-#       startype = 10           Proxima Centauri
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 # Stellar flux at 1 AU. Examples:
@@ -67,10 +100,12 @@
 # 1024.5 W m-2		Sol today x 0.75 = weak early Sun
 # 18.462 W m-2		The feeble Gl581
+# 19.960 W m-2		Gl581 with e=0.38 orbital average
 Fat1AU = 1366.0
+
 
 ## Tracer and aerosol options 
 ## ~~~~~~~~~~~~~~~~~~~~~~~~~~
-# Gravitational sedimentation of tracers (KEEP FALSE FOR NOW) ?
-sedimentation = .false.
+# Gravitational sedimentation of tracers (just H2O ice for now) ?
+sedimentation = .true.
 
 ## Other physics options
@@ -92,5 +127,17 @@
 ## ~~~~~~~~~~~~~~~~~~~~~~~~~~
 # Number of radiatively active aerosols
-naerkind=1
+naerkind = 1
+# Varying H2O cloud fraction?
+CLFvarying    = .true.
+# H2O cloud fraction?
+CLFfixval     = 1.
+# number mixing ratio of CO2 ice particles
+Nmix_co2      = 1.e5
+# basic dust opacity
+dusttau       = 0.0
+# water cloud pressure level (norm. by psurf)
+cloudlvl      = 0.0
+# atm mass update due to tracer evaporation/condensation?
+mass_redistrib = .true.
 # Radiatively active CO2 aerosol?
 aeroco2       = .false.
@@ -101,24 +148,16 @@
 # Fixed water aerosol distribution?
 aerofixh2o  = .false.
-# basic dust opacity
-dusttau       = 0.0
-# Varying H2O cloud fraction?
-CLFvarying    = .true.
-# H2O cloud fraction if fixed?
-CLFfixval     = 0.5
-# fixed radii for cloud particles?
-radfixed=.false.
-# number mixing ratio of CO2 ice particles
-Nmix_co2      = 100000.
+# Radiatively active sulfur aersol?
+aeroh2so4     = .false.
+# fixed radii for h2o cloud particles?
+radfixed=.true.
 # number mixing ratio of water particles (for rafixed=.false.)
-Nmix_h2o      = 1.e7
+Nmix_h2o      = 4e6
 # number mixing ratio of water ice particles (for rafixed=.false.)
-Nmix_h2o_ice      = 5.e5
-# radius of H2O water particles (for rafixed=.true.):
-rad_h2o=10.e-6
+Nmix_h2o_ice      = 2.e4
+# radius of H2O water particles (for rafixed=.true.): (CHANGED FROM 10 TO 12 AFTER BENJAMIN)
+rad_h2o=12.e-6
 # radius of H2O ice particles (for rafixed=.true.):
 rad_h2o_ice=35.e-6
-# atm mass update due to tracer evaporation/condensation?
-mass_redistrib = .false.
 
 ## Water options 
@@ -130,21 +169,16 @@
 # Model water precipitation (including coagulation etc.)
 waterrain     = .true.
+# Moist adjustment
+moistadjustment = .true.
 # Use simple precipitation scheme?
 precip_scheme=4
 # multiplicative constant in Boucher 95 precip scheme
-Cboucher=1.
-# WATER: hydrology ?
+Cboucher=0.6
+# Include hydrology ?
 hydrology     = .true.
-# Spectral Dependant Albedo ?
-albedo_spectral_mode=.false.
-# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-# If albedo_spectral_mode=.true., albedosnow becomes the 0.5 micron snow albedo.
-#
-# albedosnow = 0.95  (0.73 Sun-integrated) for fresh snow.
-#            = 0.50  (0.39 Sun-integrated) for dirty snow.
-#            = 0.78  (0.60 Sun-integrated) for 'realistic' snow.
-# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# active runoff ?
+activerunoff  = .true.
 # H2O snow (and ice) albedo ?
-albedosnow    = 0.60
+albedosnow    = 0.65
 # Maximum sea ice thickness ?
 maxicethick   = 10.
@@ -153,11 +187,9 @@
 # Evolve surface water sources ?
 sourceevol    = .false.
+# compute lightning rate ?
+compute_lightning     = .true.
 
 ## CO2 options 
 ## ~~~~~~~~~~~
-# Co2 ice albedo ?
-albedoco2ice   = 0.5
-# gas is non-ideal CO2 ?
-nonideal      = .false.
 # call CO2 condensation ?
 co2cond       = .false.
@@ -165,2 +197,33 @@
 nearco2cond   = .false.
 
+## Subsurface options
+## ~~~~~~~~~~~~~~~~~~
+# Number of subsurface layers (For Earth 14 is OK; for Mars 18)
+nsoilmx=14
+# Thickness of topmost soil layer (m) (For Earth 0.03 is OK; for Mars 0.0002)
+lay1_soil=0.03
+#Coefficient for soil layer thickness distribution (default is 2)
+alpha_soil=2
+
+## Ocean options
+## ~~~~~~~~~~~~~
+# Model slab-ocean (Main flag for slab ocean)
+ok_slab_ocean = .true.
+# The following flags can only be set to true if ok_slab_ocean is true
+# Ekman transport
+slab_ekman = .true.
+# Ekman zonal advection
+slab_ekman_zonadv = .true.
+# Horizontal diffusion (default coef_hdiff=25000., can be changed)
+slab_hdiff = .true.
+# Slab-ocean timestep (in physics timesteps)
+cpl_pas = 1
+# sea-ice
+#ok_slab_sic   = .true.
+# Gent-McWilliams Scheme (can only be true if slab_ekman is true)
+slab_gm   = .true.
+# Slab convective adjustment? 0 - no, 1 - yes
+slab_cadj = 1
+# H2O snow (and ice) albedo for sea ?
+#albedosnowsea    = 0.65
+